

//	This source and Genetic Text Complexity Display method apply to GNU General Public License. 
//			Copyright (C) 2001-2009 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//			Genetic Text Complexity Display
//			written by Dzinleski Jasenko September,2009



#include 	<stdio.h>
#include 	<string.h>
#include 	<math.h>


#define 	mult_	1
#define 	mp	9
#define 	cl_100	100000
#define 	cl_1	7000


//char 		infn[256]="EEDFFE_N_1_15.ods";
//char 		infn[256]="a.jpg";
//char 		infn[256]="a.bmp";
char 		infn[256]="book_sd_1.txt";

char 		outfn1[256]="idx_out_1.mar";
char 		outfn2[256]="diff_out_2.mar";
char 		outfn3[256]="mdump_out.txt";

FILE		*f1,*f2,*f3,*f4;

int 		ba16[16][16][16][16][2];	int	ba16i=0;
int			bg[cl_100][4][4];			int	bgi=0;
int			m_ab[cl_100][256];

int 		nH,nL;

int			b15=((0xffff>>1)<<1);
int			b14=((0xffff>>2)<<2);
int			b13=((0xffff>>3)<<3);
int			b12=((0xffff>>4)<<4);
int			b11=((0xffff>>5)<<5);
int			b10=((0xffff>>6)<<6);
int			b09=((0xffff>>7)<<7);

int			na[cl_100][2];				int	nai=0;

char		n_s[256];
char		p_s[256];

double		sq[cl_1];					int	sqi=0;
double		id[cl_1][100][3];			int	idi=0;
int			l14[cl_1][6];				int	l14i=0;





int p_format(double in_n,char fm[256],char arr0[256])
{

int		sig;
char		arr1[256];
double 		iv,fv;
__int64	lv,rv;
char		fa[256];int	fai=0;
int		i,j,k,l,m,n,e;


	if(in_n<0){sig=1;in_n*=-1.0;iv=in_n;}else{sig=0;iv=in_n;}

	for(i=0;i<256;++i){fa[i]='\0';}fai=0;
	for(j=0;j<256;++j){arr0[j]='\0';}

	for(i=1;i<12;++i)
	{
		lv=(long)iv/pow(10,i);//printf("%d %d %d\n",lv,i,(long)pow(10,i));
		if(lv==0){e=i-1;break;}
	}
	if(i==12){printf("Overflow...\n");arr0[0]='0';return(0);}

	if(e-1<0)
	{
		rv=(long)iv/pow(10,e);//printf("!%c",(char)(48+rv));
		fa[fai]=(char)(48+rv);++fai;

	}else{

	rv=(long)iv/pow(10,e);//printf("!%c",(char)(48+rv));
	fa[fai]=(char)(48+rv);++fai;
	rv*=pow(10,e);fv=(long)iv-rv;
	for(i=e-1;i>=0;--i)
	{
		lv=(long)fv/pow(10,i);//printf("!%c",(char)(48+lv));
		fa[fai]=(char)(48+lv);++fai;
		rv+=lv*pow(10,i);fv=iv;fv-=rv;
	}

	}

	//printf("%s\n",fa);

	if(strlen(fm)!=0)
	{

		m=0;l=strlen(fm);
		for(i=strlen(fm)-1;i>=0;--i)
		{if(fm[i]==','||fm[i]=='.'){if(l==strlen(fm)){l=i+1;++m;}else{++m;}}}
		k=(strlen(fm)-((strlen(fm)-l)+m))-strlen(fa);

		if(k>=0)
		{

			j=0;for(i=0;i<k;++i)
			{if(fm[i]=='.'||fm[i]==','){++k;}arr0[j]=fm[i];++j;}n=i;

			for(i=0;i<strlen(fa);++i)
			{
				if(fm[i+n]=='.'||fm[i+n]==','){arr0[j]=fm[i+n];++j;++n;}
				arr0[j]=fa[i];++j;
			}
				
			if(l!=strlen(fm))
			{
				--l;arr0[j]=fm[l];++j;
				for(i=l+1;i<strlen(fm);++i){arr0[j]=fm[i];++j;}

				iv=in_n;
				for(i=0;i<256;++i){fa[i]='\0';}fai=0;

				iv=pow(10,(strlen(fm)-(l+1)))*(iv-(double)((long)iv));

				for(i=1;i<12;++i)
				{
					lv=(long)iv/pow(10,i);//printf("%d %d %d\n",lv,i,(long)pow(10,i));
					if(lv==0){e=i-1;break;}
				}
				if(i==12){printf("Overflow...\n");arr0[0]='0';return(0);}

				if(e-1<0)
				{
					rv=(long)iv/pow(10,e);//printf("!%c",(char)(48+rv));
					fa[fai]=(char)(48+rv);++fai;

				}else{

				rv=(long)iv/pow(10,e);//printf("!%c",(char)(48+rv));
				fa[fai]=(char)(48+rv);++fai;
				rv*=pow(10,e);fv=(long)iv-rv;
				for(i=e-1;i>=0;--i)
				{
					lv=(long)fv/pow(10,i);//printf("!%c",(char)(48+lv));
					fa[fai]=(char)(48+lv);++fai;
					rv+=lv*pow(10,i);fv=iv;fv-=rv;
				}

				}

				//printf("s\n",fa);

				if((strlen(fm)-(l+1))==strlen(fa))
				{

				for(i=strlen(arr0)-1;i>=0;--i)
				{if(arr0[i]=='.'||arr0[i]==','){j=i;break;}}++j;
				for(i=0;i<strlen(fa);++i){arr0[j]=fa[i];++j;}

				}else{

					k=(strlen(fm)-(l+1))-strlen(fa);
					for(i=strlen(arr0)-1;i>=0;--i)
					{if(arr0[i]=='.'||arr0[i]==','){j=i;break;}}++j;
					for(i=0;i<k;++i){arr0[j]='0';++j;}
					for(i=0;i<strlen(fa);++i){arr0[j]=fa[i];++j;}

				}

			}

		}else{

			k=strlen(fa)-(strlen(fm)-((strlen(fm)-l)+m));
			j=0;for(i=0;i<k;++i){arr0[j]=fa[i];++j;}n=i;
			
			for(i=n;i<strlen(fa);++i)
			{
				if(fm[i-n]=='.'||fm[i-n]==','){arr0[j]=fm[i-n];++j;--n;}
				arr0[j]=fa[i];++j;
			}

			if(l!=strlen(fm))
			{
				--l;arr0[j]=fm[l];++j;
				for(i=l+1;i<strlen(fm);++i){arr0[j]=fm[i];++j;}

				iv=in_n;
				for(i=0;i<256;++i){fa[i]='\0';}fai=0;

				iv=pow(10,(strlen(fm)-(l+1)))*(iv-(double)((long)iv));

				for(i=1;i<12;++i)
				{
					lv=(long)iv/pow(10,i);//printf("%d %d %d\n",lv,i,(long)pow(10,i));
					if(lv==0){e=i-1;break;}
				}
				if(i==12){printf("Overflow...\n");arr0[0]='0';return(0);}

				if(e-1<0)
				{
					rv=(long)iv/pow(10,e);//printf("!%c",(char)(48+rv));
					fa[fai]=(char)(48+rv);++fai;

				}else{

				rv=(long)iv/pow(10,e);//printf("!%c",(char)(48+rv));
				fa[fai]=(char)(48+rv);++fai;
				rv*=pow(10,e);fv=(long)iv-rv;
				for(i=e-1;i>=0;--i)
				{
					lv=(long)fv/pow(10,i);//printf("!%c",(char)(48+lv));
					fa[fai]=(char)(48+lv);++fai;
					rv+=lv*pow(10,i);fv=iv;fv-=rv;
				}

				}

				//printf("s\n",fa);

				if((strlen(fm)-(l+1))==strlen(fa))
				{

				for(i=strlen(arr0)-1;i>=0;--i)
				{if(arr0[i]=='.'||arr0[i]==','){j=i;break;}}++j;
				for(i=0;i<strlen(fa);++i){arr0[j]=fa[i];++j;}

				}else{

					k=(strlen(fm)-(l+1))-strlen(fa);
					for(i=strlen(arr0)-1;i>=0;--i)
					{if(arr0[i]=='.'||arr0[i]==','){j=i;break;}}++j;
					for(i=0;i<k;++i){arr0[j]='0';++j;}
					for(i=0;i<strlen(fa);++i){arr0[j]=fa[i];++j;}

				}
				
			}

		}

	}else{

		j=0;for(i=0;i<strlen(fa);++i){arr0[j]=fa[i];++j;}

	}

	for(i=0;i<strlen(arr0);++i){if(arr0[i]=='#'){arr0[i]=' ';}}
	for(i=0;i<strlen(arr0)-1;++i){if((arr0[i]==' ')&&(arr0[i+1]==','||arr0[i+1]=='.')){arr0[i+1]=' ';}}

	if(sig==1)
	{
		for(i=0;i<256;++i){arr1[i]='\0';}
		j=0;arr1[j]='-';++j;
		for(i=0;i<strlen(arr0);++i){arr1[j]=arr0[i];++j;}
		for(i=0;i<256;++i){arr0[i]='\0';}
		j=0;for(i=0;i<strlen(arr1);++i){arr0[j]=arr1[i];++j;}
	}

	//printf("%s\n",arr0);



	return(0);
}

double p_val(char arr0[256])
{

	int	j=0,k=0,l;

	long		fr;
	int		rvi;
	long		rvl;
	__int64	rvd;
	double		rvd_;

	char 		arr1[256];

	for(j=0;j<256;++j){arr1[j]='\0';}
	l=0;for(j=0;j<strlen(arr0);++j){if((arr0[j]>='0'&&arr0[j]<='9')||(arr0[j]=='.'||arr0[j]==',')){arr1[l]=arr0[j];++l;}}

	for(j=0;j<256;++j){arr0[j]='\0';}l=0;for(j=0;j<strlen(arr1);++j){arr0[l]=arr1[j];++l;}

	for(j=0;j<strlen(arr0);++j){if(arr0[j]=='.'){break;}}

	if(j==strlen(arr0))
	{
		rvl=0;l=-1;
		for(j=-1+strlen(arr0);j>=0;--j)
		{
			++l;rvl+=(long)(-48+arr0[j])*pow(10,l);
		}
		rvi=(int)rvl;
		rvd_=(double)rvl;

	}else{

			fr=0;l=-1;
			for(k=-1+strlen(arr0);k>j;--k)
			{
				++l;fr+=(long)(-48+arr0[k])*pow(10,l);
			}

			rvd=0;l=-1;
			for(k=j-1;k>=0;--k)
			{
				++l;rvd+=(__int64)(-48+arr0[k])*pow(10,l);

			}rvd*=(__int64)pow(10,strlen(arr0)-j-1);

			rvd_=(double)(rvd+(__int64)fr)/(__int64)pow(10,strlen(arr0)-j-1);
				
	}

	return(rvd_);
}

int c_1(long spos)
{

	char	fld[100][256];
	int		fi=0;
	int		fl[100];

	int		fbyte;
	int		ai;

	int 	i,j,k,l,m;

	int	n;
	int	a,b,c;
	int	b1=0,b2=0,b3=0,b4=0,b5=0,b6=0,b7=0;


	f1=fopen(infn,"rb");

	nH=getc(f1);
	nL=getc(f1);

	while(!feof(f1))
	{
		if(ba16[(nH&0xf0)>>4][nH&0x0f][(nL&0xf0)>>4][nL&0x0f][0]==-1)
		{
			ba16[(nH&0xf0)>>4][nH&0x0f][(nL&0xf0)>>4][nL&0x0f][0]=ba16i;++ba16i;
			ba16[(nH&0xf0)>>4][nH&0x0f][(nL&0xf0)>>4][nL&0x0f][1]=1;
		}else{
			++ba16[(nH&0xf0)>>4][nH&0x0f][(nL&0xf0)>>4][nL&0x0f][1];
		}

		nH=nL;nL=getc(f1);
	}

	if(feof(f1)){spos=-1;}else{spos=ftell(f1);}
	fclose(f1);

	return(spos);
}

int c_2()
{
	int	i,j,k,l;
	int	a,b;
	int	ma,mb;

	int	m_[cl_1][2];
	int	mi[cl_1];
	int	mj[cl_1];
	int	mk[cl_1];
	int	ml[cl_1];

	int	p_[4];
	int	pi[4];
	int	pj[4];
	int	pk[4];
	int	pl[4];

	int	c=0;

	
	c=0;
	for(i=0;i<16;++i)
	{
		for(j=0;j<16;++j)
		{
			for(k=0;k<16;++k)
			{
				for(l=0;l<16;++l)
				{
					if(ba16[i][j][k][l][0]!=-1)
					{
						m_[c][0]=ba16[i][j][k][l][1];
						m_[c][1]=c;
						mi[c]=i;mj[c]=j;mk[c]=k;ml[c]=l;
						++c;
					}
				}
			}
		}
	}

	for(i=0;i<c;++i)
	{
		for(j=0;j<c;++j)
		{
			if(m_[i][0]<m_[j][0])
			{
				a=m_[i][0];
				b=m_[i][1];
				m_[i][0]=m_[j][0];
				m_[i][1]=m_[j][1];
				m_[j][0]=a;
				m_[j][1]=b;
			}
		}
	}



	for(i=0;i<4;++i){pi[i]=-1;pj[i]=-1;pk[i]=-1;pl[i]=-1;}

	for(a=0;a<c;++a)
	{
		for(i=0;i<4;++i){if(pi[i]==mi[m_[a][1]]){break;}}
		if(i==4)
		{
			for(i=0;i<4;++i){if(pi[i]==-1){pi[i]=mi[m_[a][1]];break;}}
			if(i==4)
			{
		
				bg[bgi][0][0]=pi[0];
				bg[bgi][0][1]=pi[1];
				bg[bgi][0][2]=pi[2];
				bg[bgi][0][3]=pi[3];

				bg[bgi][1][0]=pj[0];
				bg[bgi][1][1]=pj[1];
				bg[bgi][1][2]=pj[2];
				bg[bgi][1][3]=pj[3];

				bg[bgi][2][0]=pk[0];
				bg[bgi][2][1]=pk[1];
				bg[bgi][2][2]=pk[2];
				bg[bgi][2][3]=pk[3];

				bg[bgi][3][0]=pl[0];
				bg[bgi][3][1]=pl[1];
				bg[bgi][3][2]=pl[2];
				bg[bgi][3][3]=pl[3];

				++bgi;

				for(i=0;i<4;++i){pi[i]=-1;pj[i]=-1;pk[i]=-1;pl[i]=-1;}

				pi[0]=mi[m_[a][1]];
				pj[0]=mj[m_[a][1]];
				pk[0]=mk[m_[a][1]];
				pl[0]=ml[m_[a][1]];
				continue;

			}
		}

		for(i=0;i<4;++i){if(pj[i]==mj[m_[a][1]]){break;}}
		if(i==4)
		{
			for(i=0;i<4;++i){if(pj[i]==-1){pj[i]=mj[m_[a][1]];break;}}
			if(i==4)
			{
		
				bg[bgi][0][0]=pi[0];
				bg[bgi][0][1]=pi[1];
				bg[bgi][0][2]=pi[2];
				bg[bgi][0][3]=pi[3];

				bg[bgi][1][0]=pj[0];
				bg[bgi][1][1]=pj[1];
				bg[bgi][1][2]=pj[2];
				bg[bgi][1][3]=pj[3];

				bg[bgi][2][0]=pk[0];
				bg[bgi][2][1]=pk[1];
				bg[bgi][2][2]=pk[2];
				bg[bgi][2][3]=pk[3];

				bg[bgi][3][0]=pl[0];
				bg[bgi][3][1]=pl[1];
				bg[bgi][3][2]=pl[2];
				bg[bgi][3][3]=pl[3];

				++bgi;

				for(i=0;i<4;++i){pi[i]=-1;pj[i]=-1;pk[i]=-1;pl[i]=-1;}

				pi[0]=mi[m_[a][1]];
				pj[0]=mj[m_[a][1]];
				pk[0]=mk[m_[a][1]];
				pl[0]=ml[m_[a][1]];
				continue;


			}
		}

		for(i=0;i<4;++i){if(pk[i]==mk[m_[a][1]]){break;}}
		if(i==4)
		{
			for(i=0;i<4;++i){if(pk[i]==-1){pk[i]=mk[m_[a][1]];break;}}
			if(i==4)
			{
		
				bg[bgi][0][0]=pi[0];
				bg[bgi][0][1]=pi[1];
				bg[bgi][0][2]=pi[2];
				bg[bgi][0][3]=pi[3];

				bg[bgi][1][0]=pj[0];
				bg[bgi][1][1]=pj[1];
				bg[bgi][1][2]=pj[2];
				bg[bgi][1][3]=pj[3];

				bg[bgi][2][0]=pk[0];
				bg[bgi][2][1]=pk[1];
				bg[bgi][2][2]=pk[2];
				bg[bgi][2][3]=pk[3];

				bg[bgi][3][0]=pl[0];
				bg[bgi][3][1]=pl[1];
				bg[bgi][3][2]=pl[2];
				bg[bgi][3][3]=pl[3];

				++bgi;

				for(i=0;i<4;++i){pi[i]=-1;pj[i]=-1;pk[i]=-1;pl[i]=-1;}

				pi[0]=mi[m_[a][1]];
				pj[0]=mj[m_[a][1]];
				pk[0]=mk[m_[a][1]];
				pl[0]=ml[m_[a][1]];
				continue;


			}
		}

		for(i=0;i<4;++i){if(pl[i]==ml[m_[a][1]]){break;}}
		if(i==4)
		{
			for(i=0;i<4;++i){if(pl[i]==-1){pl[i]=ml[m_[a][1]];break;}}
			if(i==4)
			{
		
				bg[bgi][0][0]=pi[0];
				bg[bgi][0][1]=pi[1];
				bg[bgi][0][2]=pi[2];
				bg[bgi][0][3]=pi[3];

				bg[bgi][1][0]=pj[0];
				bg[bgi][1][1]=pj[1];
				bg[bgi][1][2]=pj[2];
				bg[bgi][1][3]=pj[3];

				bg[bgi][2][0]=pk[0];
				bg[bgi][2][1]=pk[1];
				bg[bgi][2][2]=pk[2];
				bg[bgi][2][3]=pk[3];

				bg[bgi][3][0]=pl[0];
				bg[bgi][3][1]=pl[1];
				bg[bgi][3][2]=pl[2];
				bg[bgi][3][3]=pl[3];

				++bgi;

				for(i=0;i<4;++i){pi[i]=-1;pj[i]=-1;pk[i]=-1;pl[i]=-1;}

				pi[0]=mi[m_[a][1]];
				pj[0]=mj[m_[a][1]];
				pk[0]=mk[m_[a][1]];
				pl[0]=ml[m_[a][1]];
				continue;


			}
		}
	}	

	printf("group cnt %d\n",bgi);

	for(i=0;i<cl_100;++i){na[i][0]=-1;}

	for(a=0;a<bgi;++a)
	{
		m_ab[a][0]=0;
		for(i=0;i<4;++i)
		{
			if(bg[a][0][i]==-1){break;}
			
			for(j=0;j<4;++j)
			{
				if(bg[a][1][j]==-1){break;}

				for(k=0;k<4;++k)
				{

					if(bg[a][2][k]==-1){break;}

					for(l=0;l<4;++l)
					{

						if(bg[a][3][l]==-1){break;}
					
						//printf("%d %c %c  ",a,((bg[a][0][i]<<4)|bg[a][1][j]),((bg[a][2][k]<<4)|bg[a][3][l]));

						++m_ab[a][0];
						m_ab[a][m_ab[a][0]]=(bg[a][0][i]<<12)|(bg[a][1][j]<<8)|(bg[a][2][k]<<4)|(bg[a][3][l]);
		
						if(ba16[bg[a][0][i]][bg[a][1][j]][bg[a][2][k]][bg[a][3][l]][0]!=-1)
						{
							na[(bg[a][0][i]<<12)|(bg[a][1][j]<<8)|(bg[a][2][k]<<4)|(bg[a][3][l])][0]=a;
							na[(bg[a][0][i]<<12)|(bg[a][1][j]<<8)|(bg[a][2][k]<<4)|(bg[a][3][l])][1]=
							ba16[bg[a][0][i]][bg[a][1][j]][bg[a][2][k]][bg[a][3][l]][1];
							++nai;
						}
					}
				}
			}
		}

		/*
		printf("---------------------\n");
		printf(".%d.\n",a);

		for(i=0;i<4&&bg[a][0][i]!=-1;++i){printf("%d ",bg[a][0][i]);}printf("\n");
		for(i=0;i<4&&bg[a][1][i]!=-1;++i){printf("%d ",bg[a][1][i]);}printf("\n");
		for(i=0;i<4&&bg[a][2][i]!=-1;++i){printf("%d ",bg[a][2][i]);}printf("\n");
		for(i=0;i<4&&bg[a][3][i]!=-1;++i){printf("%d ",bg[a][3][i]);}printf("\n");

		printf("\n");
		printf("\n");
		*/

	}

	return(0);
}

int main(int argc,char *argv[])
{

	long		pos=0;
	int			i,j,k,l,m,n;
	int			a,b,c,d;
	int			il,jl;
	double		ad,bd,mxd,mnd;


	if(argv[1]!=NULL)
	{
  		strcpy(infn,argv[1]);
		if(infn[0]=='-')
		{
			if(infn[1]=='l'||infn[1]=='e')
			{
				printf("\nASCII Text File Sequence Redundance Dump  \n");
				printf("written by Dzinleski Jasenko September,2009\n");
				printf("\nOS Win32 VRM 2.0.1\n\n");
				printf("\n");

				printf("\tThis source and Sequence Redundance method apply to GNU General Public License.\n");
				printf("\t		Copyright (C) 2009 Jasenko Dzinleski \n");
				printf("\n");
				printf("\t	This program is free software; you can redistribute it\n");
				printf("\tand/or modify it under the terms of the GNU General Public License as\n");
				printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
				printf("\tLicense, or (at your option) any later version.\n");
				printf("\n");
				printf("\tThis program is distributed in the hope that it will be useful, but\n");
				printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
				printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
				printf("\tGeneral Public License for more details.\n");
				printf("\n");
				printf("\tYou should have received a copy of the GNU General Public License along\n");
				printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
				printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
				printf("\n");

				return(0);

			}else{
				if(infn[1]=='h')
				{
					printf("\nASCII Text File Sequence Redundance Dump  \n");
					printf("written by Dzinleski Jasenko September,2009\n");
					printf("\nOS Win32 VRM 2.0.1\n\n");
					printf("\n");
					printf("mmd1 <filename>\n");
					printf("\n");
					return(0);

				}else{return(0);}
			}
		}else{f1=fopen(infn,"rb");if(f1==NULL){printf("No input file...\n");return(0);}else{fclose(f1);}}

	}else{

			printf("\nASCII Text File Sequence Redundance Dump  \n");
			printf("written by Dzinleski Jasenko September,2009\n");
			printf("\nOS Win32 VRM 2.0.1\n\n");

		return(0);
	}


	printf("\nASCII Text File Sequence Redundance Dump  \n");
	printf("written by Dzinleski Jasenko September,2009\n");
	printf("\nOS Win32 VRM 2.0.1\n\n");


	f1=fopen(infn,"rb");
	if(f1==NULL){printf("No file...\n");return(1);}else{fclose(f1);}



	
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l){ba16[i][j][k][l][0]=-1;ba16[i][j][k][l][1]=0;}}}}

	while(pos!=-1){pos=c_1(pos);}

	printf("number cnt %d\n",ba16i);

	c_2();

	f1=fopen(infn,"rb");	
	f2=fopen(outfn1,"wb");	

	nH=getc(f1);
	nL=getc(f1);

	while(!feof(f1))
	{
		n=((nH&0x00ff)<<8)|(nL&0x00ff);

		if(na[n][0]!=-1)
		{
			fprintf(f2,"%c%c%c%c ",
				65+((na[n][0]&0xf000)>>12),
				65+((na[n][0]&0x0f00)>>8),
				65+((na[n][0]&0x00f0)>>4),
				65+((na[n][0]&0x000f)>>0)
				);

			if(l14i==0)
			{
				l14[l14i][0]=65+((na[n][0]&0xf000)>>12);
				l14[l14i][1]=65+((na[n][0]&0x0f00)>>8);
				l14[l14i][2]=65+((na[n][0]&0x00f0)>>4);
				l14[l14i][3]=65+((na[n][0]&0x000f)>>0);
				l14[l14i][4]=na[n][0];
				l14[l14i][5]=na[n][0];
				++l14i;
			}else{
				for(i=0;i<l14i;++i)
				{
					if
					(
					65+((na[n][0]&0xf000)>>12)==l14[i][0]&&
					65+((na[n][0]&0x0f00)>>8)==l14[i][1]&&
					65+((na[n][0]&0x00f0)>>4)==l14[i][2]&&
					65+((na[n][0]&0x000f)>>0)==l14[i][3]
					)
					{l14[i][5]+=na[n][0];break;}
				}
				if(i==l14i)
				{
					l14[l14i][0]=65+((na[n][0]&0xf000)>>12);
					l14[l14i][1]=65+((na[n][0]&0x0f00)>>8);
					l14[l14i][2]=65+((na[n][0]&0x00f0)>>4);
					l14[l14i][3]=65+((na[n][0]&0x000f)>>0);
					l14[l14i][4]=na[n][0];
					l14[l14i][5]=na[n][0];
					++l14i;
				}
			}
		}

		nH=nL;nL=getc(f1);
	}
	fclose(f1);
	fclose(f2);

	//printf("................\n");
	printf("index cnt %d\n",l14i);

	for(i=0;i<cl_1;++i){id[i][0][0]=(double)-1;}
	
	ad=-1;
	f1=fopen(infn,"rb");	
	f3=fopen(outfn2,"wb");	

	nH=getc(f1);
	nL=getc(f1);
	
	while(!feof(f1))
	{

		n=((nH&0x00ff)<<8)|(nL&0x00ff);
		if(na[n][0]!=-1)
		{
			for(i=0;i<l14i;++i){if(na[n][0]==l14[i][4]){break;}}
			if(i!=l14i)
			{

				fprintf(f3,"%c %c\t",nH,nL);

				if(ad==-1)
				{
					ad=((double)l14[i][5]/(double)(1+l14[i][4]));
					p_format(ad,"0.0",p_s);
					fprintf(f3,"%s\t",p_s);

					p_format(ad,"0.000",p_s);ad=p_val(p_s);
					sq[sqi]=ad;j=sqi;++sqi;
					fprintf(f3,"%d\n",j);

				}else{

					if(((double)l14[i][5]/(double)(1+l14[i][4]))>=ad){ad=((double)l14[i][5]/(double)(1+l14[i][4]))-ad;}else{
						ad-=((double)l14[i][5]/(double)(1+l14[i][4]));}p_format(ad,"0.0",p_s);bd=p_val(p_s);

					fprintf(f3,"%s\t",p_s);
					ad=((double)l14[i][5]/(double)(1+l14[i][4]));p_format(ad,"0.000",p_s);ad=p_val(p_s);
					fprintf(f3,"%e\n",ad);
					
					for(j=0;j<sqi;++j){if(sq[j]==ad){break;}}
					if(j==sqi){sq[sqi]=ad;j=sqi;++sqi;}
					fprintf(f3,"%d\n",j);

					if(idi==0)
					{
						id[j][0][0]=1;
						id[j][(int)id[j][0][0]][0]=bd;
						id[j][(int)id[j][0][0]][1]=1;
						id[j][(int)id[j][0][0]][2]=ad;
						++idi;
					}else{
						if(id[j][0][0]==-1)
						{
							id[j][0][0]=1;
							id[j][(int)id[j][0][0]][0]=bd;
							id[j][(int)id[j][0][0]][1]=1;
							id[j][(int)id[j][0][0]][2]=ad;
							++idi;
						}else{
							for(k=1;k<=id[j][0][0];++k)
							{if(id[j][k][0]==bd&&id[j][k][2]==ad){++id[j][k][1];break;}}
							if(k==1+id[j][0][0])
							{
								++id[j][0][0];
								id[j][(int)id[j][0][0]][0]=bd;
								id[j][(int)id[j][0][0]][1]=1;
								id[j][(int)id[j][0][0]][2]=ad;
							}
						}
					}
				}
			}
		}

		nH=nL;nL=getc(f1);
	}
	fclose(f1);
	fclose(f3);

	//printf("................\n");
	printf("distances cnt %d\n",idi);

	ad=-1;
	f1=fopen(infn,"rb");	
	f4=fopen(outfn3,"w");	

	nH=getc(f1);
	nL=getc(f1);

	pos=2;

	while(!feof(f1))
	{
		n=((nH&0x00ff)<<8)|(nL&0x00ff);
		if(na[n][0]!=-1)
		{
			for(i=0;i<l14i;++i){if(na[n][0]==l14[i][4]){break;}}
			if(i!=l14i)
			{

				fprintf(f4,"%06d .%c %c.",pos,nH,nL);

				if(ad==-1){ad=((double)l14[i][5]/(double)(1+l14[i][4]));nH=nL;nL=getc(f1);++pos;fprintf(f4,".?.\n");continue;}

				if(((double)l14[i][5]/(double)(1+l14[i][4]))>=ad){ad=((double)l14[i][5]/(double)(1+l14[i][4]))-ad;}else{
					ad-=((double)l14[i][5]/(double)(1+l14[i][4]));}p_format(ad,"0.0",p_s);bd=p_val(p_s);

				ad=((double)l14[i][5]/(double)(1+l14[i][4]));p_format(ad,"0.000",p_s);ad=p_val(p_s);

				for(j=0;j<sqi;++j){if(sq[j]==ad){break;}}

				if(j!=sqi&&id[j][0][0]!=-1)
				{
					for(k=1;k<=id[j][0][0];++k){if(id[j][k][0]==bd&&id[j][k][2]==ad){break;}}

					if(k!=1+id[j][0][0])
					{

						fprintf(f4,".%05d %05d.",i,j);
						p_format(id[j][k][1],"00000.0",p_s);fprintf(f4,".%s.",p_s);

						mxd=-1;mnd=cl_100;m=0;
						for(l=1;l<=id[j][0][0];++l)
						{
							if(id[j][l][2]==ad)
							{
								if(mxd==-1){mxd=id[j][l][1];}else{
									if(mxd<id[j][l][1]){mxd=id[j][l][1];}
								}
								if(mnd==cl_100){mnd=id[j][l][1];}else{
									if(mnd>id[j][l][1]){mnd=id[j][l][1];}
								}
								++m;
							}
						}

						if(m>11&&mxd==id[j][k][1]){fprintf(f4,".!.\n");}else{
							if(m>1&&mnd<id[j][k][1]){fprintf(f4,".+.\n");}else{
								if(m>1&&mnd==id[j][k][1]){fprintf(f4,".-.\n");}else{fprintf(f4,". .\n");}
							}
						}

					}else{fprintf(f4,".?.\n");}

				}else{fprintf(f4,".?.\n");}

			}
		}
		nH=nL;nL=getc(f1);++pos;
	}
	fclose(f1);
	fclose(f4);

	printf("\nOk Marked sequences dumped to mdump_out.txt\n");

	return(0);

}

